Index: src/edu/ucsb/nceas/metacat/MetaCatServlet.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 1291)
+++ src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 1292)
@@ -317,9 +317,9 @@
         }
       } else if (action.equals("export")) {
         
-        handleExportAction(params, response, username, groupnames);
+        handleExportAction(params, response, username, groupnames, password);
       } else if (action.equals("read")) {
-        handleReadAction(params, response, username, groupnames);
+        handleReadAction(params, response, username,password, groupnames);
       } else if (action.equals("insert") || action.equals("update")) {
         PrintWriter out = response.getWriter();
         if ( (username != null) &&  !username.equals("public") ) {
@@ -364,6 +364,10 @@
         PrintWriter out = response.getWriter();
         handleGetMaxDocidAction(out, params, response);
         out.close();
+      } else if (action.equals("getrevisionanddoctype")) {
+        PrintWriter out = response.getWriter();
+        handleGetRevisionAndDocTypeAction(out, params);
+        out.close();
       } else if (action.equals("login") || action.equals("logout")) {
       } else if (action.equals("protocoltest")) {
         String testURL = "metacat://dev.nceas.ucsb.edu/NCEAS.897766.9";
@@ -699,10 +703,12 @@
    * @param user the username sent the request
    * @param groups the user's groupnames
    */
-  private void handleExportAction(Hashtable params,
-                    HttpServletResponse response, String user, String[] groups)
+  private void handleExportAction(Hashtable params, 
+    HttpServletResponse response, String user, String[] groups, String passWord)
   {
+    // Output stream
     ServletOutputStream out = null;
+    // Zip output stream
     ZipOutputStream zOut = null;
     DocumentImpl docImpls=null;
     DBQuery queryObj=null;
@@ -713,27 +719,44 @@
     try
     {
       // read the params
-      if (params.containsKey("docid")) {
+      if (params.containsKey("docid")) 
+      {
         docs = (String[])params.get("docid");
-      }
-
-   
-      queryObj = new DBQuery(saxparser);//"saxparser" have to use though
-                                              //it is not standard
+      }//if
+      // Create a DBuery to handle export
+      queryObj = new DBQuery(saxparser);
+      // Get the docid
       docId=docs[0];
+      // Make sure the client specify docid
+      if (docId == null || docId.equals(""))
+      {
+        response.setContentType("text/xml"); //MIME type
+        // Get a printwriter
+        PrintWriter pw = response.getWriter();
+        // Send back message
+        pw.println("<?xml version=\"1.0\"?>");
+        pw.println("<error>");
+        pw.println("You didn't specify requested docid");
+        pw.println("</error>");
+        // Close printwriter 
+        pw.close();
+        return;
+      }//if
+      // Get output stream
       out = response.getOutputStream();
       response.setContentType("application/zip"); //MIME type
       zOut = new ZipOutputStream(out);
-      zOut =queryObj.getZippedPackage(docId, out, user, groups);
+      zOut =queryObj.getZippedPackage(docId, out, user, groups, passWord);
       zOut.finish(); //terminate the zip file
       zOut.close();  //close the zip stream
       
-    } 
+    }//try 
     catch (Exception e)
     {
       try
       {
         response.setContentType("text/xml"); //MIME type
+        // Send error message back
         if (out != null)
         {
             PrintWriter pw = new PrintWriter(out);
@@ -741,29 +764,30 @@
             pw.println("<error>");
             pw.println(e.getMessage());
             pw.println("</error>");
+            // Close printwriter
             pw.close();
-        }
-
+            // Close output stream
+            out.close();
+        }//if
+        // Close zip output stream 
         if ( zOut != null )
         {
           zOut.close();
-        }
-      }
+        }//if
+      }//try
       catch (IOException ioe)
       {
         MetaCatUtil.debugMessage("Problem with the servlet output " +
-                           "in MetacatServlet.handleReadAction: " +
+                           "in MetacatServlet.handleExportAction: " +
                            ioe.getMessage(), 30);
-        
+      }//catch
 
-      }
-
-      MetaCatUtil.debugMessage("Error in MetacatServlet.handleReadAction: " +
+      MetaCatUtil.debugMessage("Error in MetacatServlet.handleExportAction: " +
                          e.getMessage(), 30);
+      e.printStackTrace(System.out);
       
     }//catch
-   
-
+ 
   }//handleExportAction
   
   // READ SECTION
@@ -779,10 +803,12 @@
    * @param groups the user's groupnames
    */
   private void handleReadAction(Hashtable params, HttpServletResponse response,
-                                String user, String[] groups) 
+                                String user, String passWord, String[] groups) 
   {
     ServletOutputStream out = null;
     ZipOutputStream zout = null;
+    PrintWriter pw = null;
+    boolean zip = false;
     
     try {
       String[] docs = new String[0];
@@ -789,7 +815,7 @@
       String docid = "";
       String qformat = "";
       String abstrpath = null;
-      boolean zip = false;
+      
       // read the params
       if (params.containsKey("docid")) {
         docs = (String[])params.get("docid");
@@ -857,24 +883,116 @@
       }
       
   
-    } catch (Exception e) {
+    }
+    // To handle doc not found exception
+    catch (McdbDocNotFoundException notFoundE)
+    {
+      // the docid which didn't be found
+      String notFoundDocId = notFoundE.getUnfoundDocId();
+      String notFoundRevision = notFoundE.getUnfoundRevision();
+      MetaCatUtil.debugMessage("Missed id: "+ notFoundDocId, 30);
+      MetaCatUtil.debugMessage("Missed rev: "+ notFoundRevision, 30);
+      try
+      {
+        // read docid from remote server
+        readFromRemoteMetaCat(response, notFoundDocId, notFoundRevision,
+                                              user, passWord, out, zip, zout);
+        // Close zout outputstream
+        if ( zout != null)
+        {
+          zout.close();
+        }
+        // close output stream
+        if (out != null)
+        {
+          out.close();
+        }
+        
+      }//try
+      catch ( Exception exc)
+      {
+        MetaCatUtil.debugMessage("Erorr in MetacatServlet.hanldReadAction: "+
+                                      exc.getMessage(), 30);
+        try
+        {
+          if (out != null) 
+          {
+            response.setContentType("text/xml");
+            // Send back error message by printWriter
+            pw = new PrintWriter(out);
+            pw.println("<?xml version=\"1.0\"?>");
+            pw.println("<error>");
+            pw.println(notFoundE.getMessage());
+            pw.println("</error>");
+            pw.close();
+            out.close();
+            
+          }
+          else
+          {
+           response.setContentType("text/xml"); //MIME type
+           // Send back error message if out = null
+           if (pw == null)
+           {
+             // If pw is null, open the respnose
+            pw = response.getWriter();
+           }
+           pw.println("<?xml version=\"1.0\"?>");
+           pw.println("<error>");
+           pw.println(notFoundE.getMessage());
+           pw.println("</error>");
+           pw.close();
+        }
+        // close zout
+        if ( zout != null ) 
+        { 
+          zout.close(); 
+        }
+        }//try
+        catch (IOException ie)
+        {
+          MetaCatUtil.debugMessage("Problem with the servlet output " +
+                           "in MetacatServlet.handleReadAction: " +
+                           ie.getMessage(), 30);
+        }//cathch
+      }//catch
+    }// catch McdbDocNotFoundException
+    catch (Exception e) 
+    {
       try {
-        response.setContentType("text/xml"); //MIME type
-        //PrintWriter pw = response.getWriter();
+       
         if (out != null) {
-            PrintWriter pw = new PrintWriter(out);
+            response.setContentType("text/xml"); //MIME type
+            pw = new PrintWriter(out);
             pw.println("<?xml version=\"1.0\"?>");
             pw.println("<error>");
             pw.println(e.getMessage());
             pw.println("</error>");
             pw.close();
+            out.close();
         }
-        //if ( out != null ) { out.close(); }
+        else
+        {
+           response.setContentType("text/xml"); //MIME type
+           // Send back error message if out = null
+           if ( pw == null)
+           {
+            pw = response.getWriter();
+           }
+           pw.println("<?xml version=\"1.0\"?>");
+           pw.println("<error>");
+           pw.println(e.getMessage());
+           pw.println("</error>");
+           pw.close();
+          
+        }
+        // Close zip output stream
         if ( zout != null ) { zout.close(); }
+        
       } catch (IOException ioe) {
-        System.out.println("Problem with the servlet output " +
+        MetaCatUtil.debugMessage("Problem with the servlet output " +
                            "in MetacatServlet.handleReadAction: " +
-                           ioe.getMessage());
+                           ioe.getMessage(), 30);
         ioe.printStackTrace(System.out);
         
       }
@@ -910,12 +1028,15 @@
      
       if ( doc.getRootNodeID() == 0 ) {
         // this is data file
-        ServletOutputStream out = response.getOutputStream(); 
         String filepath = util.getOption("datafilepath");
         if(!filepath.endsWith("/")) {
           filepath += "/";
         }
-        String filename = filepath + docid;      //MIME type
+        String filename = filepath + docid;
+        FileInputStream fin = null;
+        fin = new FileInputStream(filename);
+        
+        //MIME type
         String contentType = getServletContext().getMimeType(filename);
         if (contentType == null) {
           if (filename.endsWith(".xml")) {
@@ -940,9 +1061,10 @@
         response.setContentType(contentType);
         // if we decide to use "application/octet-stream" for all data returns
         // response.setContentType("application/octet-stream");
-        FileInputStream fin = null;
+       
         try {
-          fin = new FileInputStream(filename);
+          
+          ServletOutputStream out = response.getOutputStream(); 
           byte[] buf = new byte[4 * 1024]; // 4K buffer
           int b = fin.read(buf);
           while (b != -1) {
@@ -974,7 +1096,9 @@
         }
       
       }
-    } catch (Exception except) {
+    }
+    catch (Exception except) 
+    {
       throw except;
     
     }
@@ -1080,12 +1204,13 @@
           if(!filepath.endsWith("/")) {
             filepath += "/";
           }
-          String filename = filepath + doc.getDocname();
-          zentry = new ZipEntry(filename);
-          zout.putNextEntry(zentry);
+          String filename = filepath + docid;
           FileInputStream fin = null;
+          fin = new FileInputStream(filename);
           try {
-            fin = new FileInputStream(filename);
+            
+            zentry = new ZipEntry(docid);
+            zout.putNextEntry(zentry);
             byte[] buf = new byte[4 * 1024]; // 4K buffer
             int b = fin.read(buf);
             while (b != -1) {
@@ -1144,6 +1269,34 @@
    
     }
   }
+  /**
+   * If metacat couldn't find a data file or document locally, it will read this
+   * docid from its home server. This is for the replication feature
+   */
+  private void readFromRemoteMetaCat(HttpServletResponse response, String docid, 
+                     String rev, String user, String password, 
+                     ServletOutputStream out, boolean zip, ZipOutputStream zout)
+                        throws Exception
+ {
+   // Create a object of RemoteDocument, "" is for zipEntryPath
+   RemoteDocument remoteDoc = 
+                        new RemoteDocument (docid, rev,user, password, "");
+   // If it is zip format
+   if (zip)
+   {
+     remoteDoc.readDocumentFromRemoteServerByZip(zout);
+   }//if 
+   else
+   {
+     if (out == null)
+     {
+       out = response.getOutputStream();
+     }//if
+     response.setContentType("application/octet-stream");
+     remoteDoc.readDocumentFromRemoteServer(out);
+   }//else (not zip)                   
+ }//readFromRemoteMetaCat
+  
   // END OF READ SECTION
     
   // INSERT/UPDATE SECTION
@@ -1202,10 +1355,12 @@
                   getDBConnection("MetaCatServlet.handleInsertOrUpdateAction");
           serialNumber=dbConn.getCheckOutSerialNumber();
           
+          
           // write the document to the database
           try 
           {
             String accNumber = docid[0];
+            MetaCatUtil.debugMessage(""+ doAction + " " + accNumber +"...", 10);
             if (accNumber.equals("")) 
             {
               accNumber = null;
@@ -1431,6 +1586,53 @@
  
   // OTHER ACTION HANDLERS
   
+  /**
+   * Handle "getrevsionanddoctype" action
+   * Given a docid, return it's current revision and doctype from data base
+   * The output is String look like "rev;doctype"
+   */
+  private void handleGetRevisionAndDocTypeAction(PrintWriter out, 
+                                                              Hashtable params)
+  {
+    // To store doc parameter
+    String [] docs = new String[10];
+    // Store a single doc id
+    String givenDocId = null;
+    // Get docid from parameters
+    if (params.containsKey("docid")) 
+    {
+      docs = (String[])params.get("docid");
+    }
+    // Get first docid form string array
+    givenDocId = docs[0];
+   
+    try 
+    {
+      // Make sure there is a docid
+      if (givenDocId == null || givenDocId.equals(""))
+      {
+        throw new Exception("User didn't specify docid!");
+      }//if
+      
+      // Create a DBUtil object
+      DBUtil dbutil = new DBUtil();
+      // Get a rev and doctype
+      String revAndDocType = 
+                dbutil.getCurrentRevisionAndDocTypeForGivenDocument(givenDocId);
+      out.println(revAndDocType);
+
+    }//try 
+    catch (Exception e) 
+    {
+      // Handle exception
+      out.println("<?xml version=\"1.0\"?>");
+      out.println("<error>");
+      out.println(e.getMessage());
+      out.println("</error>");
+    }//catch 
+    
+  }//handleGetRevisionAndDocTypeAction
+  
   /** 
    * Handle "getaccesscontrol" action.
    * Read Access Control List from db connection in XML format
@@ -1691,18 +1893,21 @@
                            ise.getMessage());
       }
     }  
-
-    if ( action.equals("upload")) {
-      if (username != null &&  !username.equals("public")) {
-        handleUploadAction(request, response, params, fileList, 
-                           username, groupnames);
-      } else {
-        try {
+    
+    // Get the out stream
+    try {
           out = response.getWriter();
         } catch (IOException ioe2) {
           util.debugMessage("Fatal Error: couldn't get response "+
                                                               "output stream.");
         }
+    
+    if ( action.equals("upload")) {
+      if (username != null &&  !username.equals("public")) {
+        handleUploadAction(request, out, params, fileList, 
+                           username, groupnames);
+      } else {
+       
         out.println("<?xml version=\"1.0\"?>");
         out.println("<error>");
         out.println("Permission denied for " + action);
@@ -1709,11 +1914,11 @@
         out.println("</error>");
       }
     } else {
-      try {
+      /*try {
         out = response.getWriter();
       } catch (IOException ioe2) {
         System.err.println("Fatal Error: couldn't get response output stream.");
-      }
+      }*/
       out.println("<?xml version=\"1.0\"?>");
       out.println("<error>");
       out.println("Error: action not registered.  Please report this error.");
@@ -1727,16 +1932,16 @@
    * registering it in the Metacat db
    */
   private void handleUploadAction(HttpServletRequest request,
-                                  HttpServletResponse response, 
+                                  PrintWriter out, 
                                   Hashtable params, Hashtable fileList, 
                                   String username, String[] groupnames)
   {
-    PrintWriter out = null;
+    //PrintWriter out = null;
     //Connection conn = null;
     String action = null;
     String docid = null;
   
-    response.setContentType("text/xml");
+    /*response.setContentType("text/xml");
     try 
     {
       out = response.getWriter();
@@ -1744,7 +1949,7 @@
     catch (IOException ioe2) 
     {
       System.err.println("Fatal Error: couldn't get response output stream.");
-    }
+    }*/
 
     if (params.containsKey("docid")) 
     {
@@ -1764,6 +1969,7 @@
   
         try 
         {
+           //MetaCatUtil.debugMessage("Upload datafile " + docid +"...", 10);
            //If document get lock data file grant
            if (DocumentImpl.getDataFileLockGrant(docid))
            {
@@ -1775,34 +1981,15 @@
               dataDirectory.mkdirs();
               File newFile = new File(dataDirectory, docid);
               long size = filePart.writeTo(newFile);
-              if ((util.getOption("replicationsenddata")).equals("on"))
-              {
-                // force replcation data file if metacat was configured
-                if (ReplicationHandler.getServerLocation(docid)==1)
-                {//local host document
-                  //conn=util.getConnection();
-                  ForceReplicationHandler frh = new ForceReplicationHandler
-             (docid, "insert", false, ReplicationHandler.buildServerList());
-                  //conn.close();
-                }//if
-                else
-                {
-                  //if it is super hub, replication to server list
-                  if ((util.getOption("hub")).equals("super"))
-                  {
-                    ForceReplicationHandler frh = new ForceReplicationHandler
-                    (docid,true, ReplicationHandler.buildServerList());
-                    //conn.close();
-                  }//if
-                  else
-                  {
-                    //only replicate to home host of the document
-                    String id=util.getDocIdFromString(docid);
-                    ForceReplicationHandler frh = new ForceReplicationHandler
-                    (docid, true, ReplicationHandler.getHomeServer(id));
-                  }//else
-                }//else
-              }//if
+              
+              // Force replication this data file
+              // To data file, "insert" and update is same
+              // The fourth parameter is null. Because it is notification server 
+              // and this method is in MetaCatServerlet. It is original command, 
+              // not get force replication info from another metacat
+              ForceReplicationHandler frh = new ForceReplicationHandler
+                                                (docid, "insert", false, null);
+             
               // set content type and other response header fields first
               out.println("<?xml version=\"1.0\"?>");
               out.println("<success>");
